##
## requires sun make
## requires MATISSE_HOME to be set to install directory
##

MV=/bin/mv
RM=/bin/rm -f
CP=/bin/cp

# lib for matisse
MATISSE_LIBS=-lmatisse
# lib for Matisse Lite
#MATISSE_LIBS=-lmatisselite
CPPFLAGS=-I${MATISSE_HOME}/include 
# with inline functions
#CPPFLAGS=-I${MATISSE_HOME}/include -DMT_USE_INLINE

LDFLAGS=-L${MATISSE_HOME}/lib

# sun CC compiler

CCLIB_OPT=-library=Cstd,Crun -staticlib=Cstd,Crun
CXX=CC

# debug version
#CXXFLAGS = -g -mt  -instances=static ${CCLIB_OPT} -DDEBUG
CXXFLAGS = -xO2 -mt  -instances=static ${CCLIB_OPT}


LINK=$(CXX) -mt ${CCLIB_OPT}
AR=$(CXX)

# to find matisseCXX.cpp
VPATH=$(MATISSE_HOME)/include

## the Connect application
CONNECT_SRCS=\
	matisseCXX.cpp\
	Connect.cpp

CONNECT_OBJS=$(CONNECT_SRCS:.cpp=.o)
CONNECT_EXEC=Connect

## the Advanced Connect application
ADVCONNECT_SRCS=\
	matisseCXX.cpp\
	AdvancedConnect.cpp

ADVCONNECT_OBJS=$(ADVCONNECT_SRCS:.cpp=.o)
ADVCONNECT_EXEC=AdvancedConnect

## the VersionConnect application
VERCONNECT_SRCS=\
	matisseCXX.cpp\
	VersionConnect.cpp

VERCONNECT_OBJS=$(VERCONNECT_SRCS:.cpp=.o)
VERCONNECT_EXEC=VersionConnect

## the VersionNavigation application
VERNAV_SRCS=\
	matisseCXX.cpp\
	VersionNavigation.cpp

VERNAV_OBJS=$(VERNAV_SRCS:.cpp=.o)
VERNAV_EXEC=VersionNavigation

ALL_OBJS = $(CONNECT_OBJS) $(ADVCONNECT_OBJS) $(VERCONNECT_OBJS) $(VERNAV_OBJS)
ALL_EXECS=$(CONNECT_EXEC) $(ADVCONNECT_EXEC) $(VERCONNECT_EXEC) $(VERNAV_EXEC)

default: $(ALL_EXECS)


$(CONNECT_EXEC) : $(CONNECT_OBJS)
	$(LINK) -o $@ $(CONNECT_OBJS) ${LDFLAGS} $(MATISSE_LIBS)

$(ADVCONNECT_EXEC) : $(ADVCONNECT_OBJS)
	$(LINK) -o $@ $(ADVCONNECT_OBJS) ${LDFLAGS} $(MATISSE_LIBS)

$(VERCONNECT_EXEC) : $(VERCONNECT_OBJS)
	$(LINK) -o $@ $(VERCONNECT_OBJS) ${LDFLAGS} $(MATISSE_LIBS)

$(VERNAV_EXEC) : $(VERNAV_OBJS)
	$(LINK) -o $@ $(VERNAV_OBJS) ${LDFLAGS} $(MATISSE_LIBS)


clean:
	$(RM) ${ALL_OBJS} $(ALL_EXECS)


%.o : %.cpp
	$(CXX) -c $(CPPFLAGS) $(CXXFLAGS) $< -o $@
