
##
## requires sun make
## requires MATISSE_HOME to be set to install directory
##

MV=/bin/mv
RM=/bin/rm -f
CP=/bin/cp

# lib for matisse
MATISSE_LIBS=-lmatisse
# lib for Matisse Lite
#MATISSE_LIBS=-lmatisselite
CPPFLAGS=-I${MATISSE_HOME}/include 
# with inline functions
#CPPFLAGS=-I${MATISSE_HOME}/include -DMT_USE_INLINE

LDFLAGS=-L${MATISSE_HOME}/lib

# sun CC compiler
# NOTE, static linking avoids any Forte shared library version issues
CCLIB_OPT=-library=Cstd,Crun -staticlib=Cstd,Crun
CXX=CC

# debug version
#CXXFLAGS = -g -mt  -instances=static ${CCLIB_OPT} -DDEBUG
CXXFLAGS = -xO2 -mt  -instances=static ${CCLIB_OPT}


LINK=$(CXX) -mt ${CCLIB_OPT}
AR=$(CXX)

# to find matisseCXX.cpp
VPATH=$(MATISSE_HOME)/include

ODL_SRCS = Employee.cpp Person.cpp

## the ObjectsExample
OBJECTSEG_SRCS=\
	$(ODL_SRCS)\
	matisseCXX.cpp\
	ObjectsExample.cpp

OBJECTSEG_OBJS=$(OBJECTSEG_SRCS:.cpp=.o)
OBJECTSEG_EXEC=ObjectsExample

## the ValuesExample
VALUESEG_SRCS=\
	$(ODL_SRCS)\
	matisseCXX.cpp\
	ValuesExample.cpp

VALUESEG_OBJS=$(VALUESEG_SRCS:.cpp=.o)
VALUESEG_EXEC=ValuesExample

ALL_OBJS = $(OBJECTSEG_OBJS) $(VALUESEG_OBJS)
ALL_EXECS=$(OBJECTSEG_EXEC) $(VALUESEG_EXEC)

default: $(ALL_EXECS)


# so the sources are always upto date..
$(ODL_SRCS): objects.odl
	mt_sdl stubgen --lang cxx -f objects.odl

$(OBJECTSEG_EXEC) : $(OBJECTSEG_OBJS)
	$(LINK) -o $@ $(OBJECTSEG_OBJS) ${LDFLAGS} $(MATISSE_LIBS)

$(VALUESEG_EXEC) : $(VALUESEG_OBJS)
	$(LINK) -o $@ $(VALUESEG_OBJS) ${LDFLAGS} $(MATISSE_LIBS)


clean:
	$(RM) ${ALL_OBJS} $(ALL_EXECS)


%.o : %.cpp
	$(CXX) -c $(CPPFLAGS) $(CXXFLAGS) $< -o $@
