
##
## requires sun make
## requires MATISSE_HOME to be set to install directory
##

MV=/bin/mv
RM=/bin/rm -f
CP=/bin/cp

# lib for matisse
MATISSE_LIBS=-lmatisse
# lib for Matisse Lite
#MATISSE_LIBS=-lmatisselite
CPPFLAGS=-I${MATISSE_HOME}/include 
# with inline functions
#CPPFLAGS=-I${MATISSE_HOME}/include -DMT_USE_INLINE

LDFLAGS=-L${MATISSE_HOME}/lib

# sun CC compiler

CCLIB_OPT=-library=Cstd,Crun -staticlib=Cstd,Crun
CXX=CC

# debug version
#CXXFLAGS = -g -mt  -instances=static ${CCLIB_OPT} -DDEBUG
CXXFLAGS = -xO2 -mt  -instances=static ${CCLIB_OPT}


LINK=$(CXX) -mt ${CCLIB_OPT}
AR=$(CXX)

# to find matisseCXX.cpp
VPATH=$(MATISSE_HOME)/include

ODL_SRCS = Employee.cpp Person.cpp Manager.cpp
ODL_FILE = examples.odl

## the RelationshipsExample
RELSEG_SRCS=\
	$(ODL_SRCS)\
	matisseCXX.cpp\
	RelationshipsExample.cpp

RELSEG_OBJS=$(RELSEG_SRCS:.cpp=.o)
RELSEG_EXEC=RelationshipsExample

## the EPDictExample
EPEG_SRCS=\
	$(ODL_SRCS)\
	matisseCXX.cpp\
	EPDictExample.cpp

EPEG_OBJS=$(EPEG_SRCS:.cpp=.o)
EPEG_EXEC=EPDictExample

## the IndexExample
INDEXEG_SRCS=\
	$(ODL_SRCS)\
	matisseCXX.cpp\
	IndexExample.cpp

INDEXEG_OBJS=$(INDEXEG_SRCS:.cpp=.o)
INDEXEG_EXEC=IndexExample

ALL_OBJS = $(RELSEG_OBJS) $(EPEG_OBJS)  $(INDEXEG_OBJS)
ALL_EXECS=$(RELSEG_EXEC) $(EPEG_EXEC) $(INDEXEG_EXEC)
default: $(ALL_EXECS)


# so the sources are always upto date..
$(ODL_SRCS): $(ODL_FILE)
	mt_sdl stubgen --lang cxx -f $(ODL_FILE)

$(RELSEG_EXEC) : $(RELSEG_OBJS)
	$(LINK) -o $@ $(RELSEG_OBJS) ${LDFLAG./RS} $(MATISSE_LIBS)

$(EPEG_EXEC) : $(EPEG_OBJS)
	$(LINK) -o $@ $(EPEG_OBJS) ${LDFLAGS} $(MATISSE_LIBS)

$(INDEXEG_EXEC) : $(INDEXEG_OBJS)
	$(LINK) -o $@ $(INDEXEG_OBJS) ${LDFLAGS} $(MATISSE_LIBS)



clean:
	$(RM) ${ALL_OBJS} $(ALL_EXECS)


%.o : %.cpp
	$(CXX) -c $(CPPFLAGS) $(CXXFLAGS) $< -o $@
